/*
 Teachbot Re-attach servo demonstration
*/

#include <Servo.h> 
Servo servoLeft;          // Define left servo
Servo servoRight;         // Define right servo

void setup() { 
  servoLeft.attach(9);   // Set left servo to digital pin 9
  servoRight.attach(10); // Set right servo to digital pin 10
} 

void loop() {            // Loop through motion tests
  forward();             // Example: move forward
  delay(2000);           // Wait 2000 milliseconds (2 seconds)
  reverse();
  delay(2000);
  turnRight();
  delay(2000);
  turnLeft();
  delay(2000);
  stopRobot();
  delay(2000);
}

// Motion routines for forward, reverse, turns, and stop
void forward() {
  reAttach();
  servoLeft.write(0);
  servoRight.write(180);
}

void reverse() {
  reAttach();
  servoLeft.write(180);
  servoRight.write(0);
}

void turnRight() {
  reAttach();
  servoLeft.write(180);
  servoRight.write(180);
}

void turnLeft() {
  reAttach();
  servoLeft.write(0);
  servoRight.write(0);
}

void stopRobot() {
  servoLeft.detach();
  servoRight.detach();
}

void reAttach() {
  if(!servoLeft.attached())
    servoLeft.attach(9);
  if(!servoRight.attached())
    servoRight.attach(10);    
}


